/**********************************************************
FATVXeɌĂяo钊ۓIIO[`
(ChaÑR[h`[jO2̃Cɕ@)

@disk_initialize - hCȕ
  disk_status - hCȕԎ擾
  disk_read - f[^̓ǂݏo
  disk_write - f[^̏
  disk_ioctl - ̑̃hCu
  (get_fattime - tE̎擾@͕ʂɒ`)


̃[`QĂяô͎6̉ʃCiCj֐ł
int SPI_putData(BYTE *buff, int num)
@buff̃f[^num[bytes]CSPIɏóCoCgԂ
int SPI_getData(BYTE *buff, int num)
@SPInum[bytes]̃f[^buffɓ́CǂݏooCgԂ
void SPI_assertCS()
@SPICS0ɂiassertj
void SPI_negateCS()
@SPICS1ɂinegatej
void SPI_setDownCounter(unsigned char chan, unsigned char csec)
@down counter̃Zbg@time out ̌oɗp
unsigned char SPI_getDownCounter(unsigned char chan)
@down counter̓ǂݏo@time out ̌oɗp
**********************************************************/

/*------------------------------------------------------------------------/
/  MMCv3/SDv1/SDv2 (in SPI mode) control module
/-------------------------------------------------------------------------/
/
/  Copyright (C) 2010, ChaN, all right reserved.
/
/ * This software is a free software and there is NO WARRANTY.
/ * No restriction on use. You can use, modify and redistribute it for
/   personal, non-profit or commercial products UNDER YOUR RESPONSIBILITY.
/ * Redistributions of source code must retain the above copyright notice.
/
/-------------------------------------------------------------------------*/

#include <machine.h>
#include "iodefine.h"
#include "ff.h"			/* FatFs configurations and declarations */
#include "diskio.h"
#include "spi.h"

/***************************************************************************/

static void usecwait(int usec)
{
    int i,j;
    for (i=0;i<usec;i++) {
        for (j=0;j<4;j++);    /*4͎ɂċ߂l 25MHz쓮*/
    }
}

#define	_USE_CD		0	/* Use card detect contact */
#define _USE_WP		0	/* Use write protect contact */

/* MMC/SD command (in SPI) */
#define CMD0	(0)			/* GO_IDLE_STATE */
#define CMD1	(1)			/* SEND_OP_COND */
#define	ACMD41	(0x80+41)	/* SEND_OP_COND (SDC) */
#define CMD8	(8)			/* SEND_IF_COND */
#define CMD9	(9)			/* SEND_CSD */
#define CMD10	(10)		/* SEND_CID */
#define CMD12	(12)		/* STOP_TRANSMISSION */
#define ACMD13	(0x80+13)	/* SD_STATUS (SDC) */
#define CMD16	(16)		/* SET_BLOCKLEN */
#define CMD17	(17)		/* READ_SINGLE_BLOCK */
#define CMD18	(18)		/* READ_MULTIPLE_BLOCK */
#define CMD23	(23)		/* SET_BLOCK_COUNT */
#define	ACMD23	(0x80+23)	/* SET_WR_BLK_ERASE_COUNT (SDC) */
#define CMD24	(24)		/* WRITE_BLOCK */
#define CMD25	(25)		/* WRITE_MULTIPLE_BLOCK */
#define CMD41	(41)		/* SEND_OP_COND (ACMD) */
#define CMD55	(55)		/* APP_CMD */
#define CMD58	(58)		/* READ_OCR */

/* Card type flags (CardType) */
#define CT_MMC		0x01		/* MMC ver 3 */
#define CT_SD1		0x02		/* SD ver 1 */
#define CT_SD2		0x04		/* SD ver 2 */
#define CT_SDC		(CT_SD1|CT_SD2)	/* SD */
#define CT_BLOCK	0x08		/* Block addressing */



/*--------------------------------------------------------------------------
   Module Private Values
---------------------------------------------------------------------------*/

static volatile DSTATUS Stat = STA_NOINIT;	/* Disk status */

static BYTE CardType;         /* b0:MMC, b1:SDv1, b2:SDv2, b3:Block addressing */

/*-----------------------------------------------------------------------
 Wait for card ready     busyԂłȂƂmF
 0:Ready, 1:Timeout 
-----------------------------------------------------------------------*/

/*static int wait_ready (void)*/
int wait_ready (void)
{
	BYTE res;

	SPI_setDownCounter(1,50); /* Wait for ready in timeout of 500ms with ch1*/
	SPI_getData(&res,1);
	do {
		SPI_getData(&res,1);
		if (res == 0xFF) break;
	} while (SPI_getDownCounter(1));

	return res==0xFF ? 0 : 1;
}

/*-----------------------------------------------------------------------*/
/* Deselect the card and release SPI bus                                 */
/*-----------------------------------------------------------------------*/

static void deselect (void)
{
	BYTE res;
	SPI_negateCS();
	SPI_getData(&res,1);
}



/*-----------------------------------------------------------------------*/
/* Select the card and wait for ready                                    */
/*-----------------------------------------------------------------------*/

static int select (void)	/* 0:Completed, 1:Timeout */
{
	SPI_assertCS();
	if (wait_ready()) {  /*	busyԂłȂƂmF */
		deselect();
		return 1;
	}
	return 0;
}

/*-----------------------------------------------------------------------
 Receive a data packet from MMC
 0:Completed, 1:Failed 
 BYTE *buff         Data buffer to store received data
 UINT btr           Byte count (must be even number)
-------------------------------------------------------------------------*/

static int rcvr_datablock ( BYTE *buff, UINT btr)
{
	BYTE token, crc[2];

	SPI_setDownCounter(0,10);
	do {                             /* Wait for data packet in timeout of 100ms */
		SPI_getData(&token,1);
	} while ((token == 0xFF) && SPI_getDownCounter(0));
	
	if(token != 0xFE) return 1;		/* If not valid data token, retutn with error */

	SPI_getData(buff,btr);

	SPI_getData(crc,2);               /* Discard CRC */

	return 0;                         /* Return with success */
}


/*-----------------------------------------------------------------------
 Send a data packet to MMC
 0:completed, 1:Failed 
 const BYTE *buf      512 byte data block to be transmitted 
 BYTE token           Data/Stop token 
-----------------------------------------------------------------------*/

#if _READONLY == 0
static
int xmit_datablock (const BYTE *buff, BYTE token)
{
	BYTE resp, wc;

	if (wait_ready()) return 1;

	SPI_putData(&token,1);  /* Xmit data token */
	if (token != 0xFD) {	/* Is data token */
		wc = 0;
		SPI_putData(buff,514); /*512+2(crc) crcƂĂ݂𑗂*/
		SPI_getData(&resp,1);				/* Reveive data response */
		if ((resp & 0x1F) != 0x05)		/* If not accepted, return with error */
			return 1;
	}

	return 0;
}
#endif /* _READONLY */


/*-----------------------------------------------------------------------
 Send a command packet to MMC
 Returns command response (bit7==1:Send failed)
 BYTE cmd        Command byte 
 DWORD arg       Argument 
-----------------------------------------------------------------------*/

/*static BYTE send_cmd (BYTE cmd, DWORD arg)*/
BYTE send_cmd (BYTE cmd, DWORD arg)
{
	BYTE n, res;
	BYTE command[6];
	int i;


	if (cmd & 0x80) {	/* ACMD<n> is the command sequense of CMD55-CMD<n> */
		cmd &= 0x7F;
		res = send_cmd(CMD55, 0L);
		if (res > 1) return res;
	}

	/* Select the card and wait for ready */
	deselect();
	if (select()) return 0xFF;

	/* Send command packet */
	command[0]=(0x40 | cmd);            /* Start + Command index */
	command[1]=((BYTE)(arg >> 24));     /* Argument[31..24] */
	command[2]=((BYTE)(arg >> 16));     /* Argument[23..16] */
	command[3]=((BYTE)(arg >> 8));      /* Argument[15..8] */
	command[4]=((BYTE)arg);             /* Argument[7..0] */
	n = 0x01;                           /* Dummy CRC + Stop */
	if (cmd == CMD0) n = 0x95;          /* Valid CRC for CMD0(0) */
	if (cmd == CMD8) n = 0x87;          /* Valid CRC for CMD8(0x1AA) */
	command[5]=n;
	
	n = SPI_putData(command,6);

	/* Receive command response */
	if (cmd == CMD12) SPI_getData(&res,1); /* Skip a stuff byte when stop reading */
	n = 10;                                /* Wait for a valid response in timeout of 10 attempts */
	do {
		SPI_getData(&res,1);
	} while ((res & 0x80) && --n);

	return res;			/* Return with the response value */
}

/*-----------------------------------------------------------------------
 Initialize Disk Drive
 BYTE drv Physical drive nmuber (0)
------------------------------------------------------------------------*/

DSTATUS disk_initialize (BYTE drv)
{
	BYTE n, ty, cmd, ocr[4];
	BYTE dummy;

	if (drv) return STA_NOINIT;            /* Supports only single drive */
	
	deselect();
	usecwait(40);
	
	for (n = 10; n; n--) SPI_getData(&dummy,1);	/* 80 dummy clocks */

	ty = 0;
	if (send_cmd(CMD0, 0L) == 1) {          /* Enter Idle state */
		SPI_setDownCounter(0,100);          /* Initialization timeout of 1000 msec */
		if (send_cmd(CMD8, 0x1AAL) == 1) {	/* SDv2? */
			SPI_getData(ocr,4);		/* Get trailing return value of R7 resp */
			if (ocr[2] == 0x01 && ocr[3] == 0xAA) {				/* The card can work at vdd range of 2.7-3.6V */
				while (SPI_getDownCounter(0) && send_cmd(ACMD41, 1UL << 30));	/* Wait for leaving idle state (ACMD41 with HCS bit) */
				if (SPI_getDownCounter(0) && send_cmd(CMD58, 0L) == 0) {		/* Check CCS bit in the OCR */
					SPI_getData(ocr,4);
					ty = (ocr[0] & 0x40) ? CT_SD2 | CT_BLOCK : CT_SD2;	/* SDv2 */
				}
			}
		} else {							/* SDv1 or MMCv3 */
			if (send_cmd(ACMD41, 0L) <= 1) 	{
				ty = CT_SD1; cmd = ACMD41;	/* SDv1 */
			} else {
				ty = CT_MMC; cmd = CMD1;	/* MMCv3 */
			}
			while (SPI_getDownCounter(0) && send_cmd(cmd, 0L));		/* Wait for leaving idle state */
			if (!SPI_getDownCounter(0) || send_cmd(CMD16, 512L) != 0) {	/* Set R/W block length to 512 */
				ty = 0;
			}
		}
	}
	CardType = ty;
	deselect();

	if (ty) {			/* Initialization succeded */
		Stat &= ~STA_NOINIT;		/* Clear STA_NOINIT */
	}
	
	return Stat;
}

/*-----------------------------------------------------------------------*/
/* Get Disk Status                                                       */
/*         BYTE drv  Drive number (0)                                    */
/*-----------------------------------------------------------------------*/

DSTATUS disk_status (BYTE drv)
{
	return (drv) ? STA_NODISK : Stat;
}

/*-----------------------------------------------------------------------
 Read Sector(s)
	BYTE drv        Physical drive nmuber (0)
	BYTE *buff      Pointer to the data buffer to store read data
	DWORD sector    Start sector number (LBA)
	BYTE count      Sector count (1..255)
-----------------------------------------------------------------------*/

DRESULT disk_read (BYTE drv, BYTE *buff, DWORD sector, BYTE count)
{
	if (drv || !count) return RES_PARERR;
	if (Stat & STA_NOINIT) return RES_NOTRDY;

	if (!(CardType & CT_BLOCK)) sector *= 512;	/* Convert to byte address if needed */

	if (count == 1) {	/* Single block read */
		if ((send_cmd(CMD17, sector) == 0)	/* READ_SINGLE_BLOCK */
			&& !rcvr_datablock(buff, 512))
			count = 0;
	}
	else {				/* Multiple block read */
		if (send_cmd(CMD18, sector) == 0) {	/* READ_MULTIPLE_BLOCK */
			do {
				if (rcvr_datablock(buff, 512)) break;
				buff += 512;
			} while (--count);
			send_cmd(CMD12, 0L);				/* STOP_TRANSMISSION */
		}
	}
	deselect();

	return count ? RES_ERROR : RES_OK;
}

/*-----------------------------------------------------------------------
 Write Sector(s)
	BYTE drv            Physical drive nmuber (0) 
	const BYTE *buff    Pointer to the data to be written
	DWORD sector        Start sector number (LBA)
	BYTE count          Sector count (1..255)
-----------------------------------------------------------------------*/

#if _READONLY == 0
DRESULT disk_write (BYTE drv, const BYTE *buff, DWORD sector, BYTE count)
{
	if (drv || !count) return RES_PARERR;
	if (Stat & STA_NOINIT) return RES_NOTRDY;
	if (Stat & STA_PROTECT) return RES_WRPRT;

	if (!(CardType & CT_BLOCK)) sector *= 512;	/* Convert to byte address if needed */

	if (count == 1) {	/* Single block write */
		if ((send_cmd(CMD24, sector) == 0)	/* WRITE_BLOCK */
			&& !xmit_datablock(buff, 0xFE))
			count = 0;
	}
	else {				/* Multiple block write */
		if (CardType & CT_SDC) send_cmd(ACMD23, (DWORD)count);
		if (send_cmd(CMD25, sector) == 0) {	/* WRITE_MULTIPLE_BLOCK */
			do {
				if (xmit_datablock(buff, 0xFC)) break;
				buff += 512;
			} while (--count);
			if (!xmit_datablock(0, 0xFD))	/* STOP_TRAN token */
				count = 1;
		}
	}
	deselect();

	return count ? RES_ERROR : RES_OK;
}
#endif /* _READONLY == 0 */

/*-----------------------------------------------------------------------
 Miscellaneous Functions
	BYTE drv        Physical drive nmuber (0) 
	BYTE ctrl       Control code 
	void *buff      Buffer to send/receive control data 
-----------------------------------------------------------------------*/

DRESULT disk_ioctl (BYTE drv, BYTE ctrl, void *buff)
{
	DRESULT res;
	BYTE n, csd[16], *ptr = buff;
	WORD csize;
	BYTE dummy;


	if (drv) return RES_PARERR;
	if (Stat & STA_NOINIT) return RES_NOTRDY;

	res = RES_ERROR;
	switch (ctrl) {
		case CTRL_SYNC :		/* Make sure that no pending write process */
			if (!select()) {
				deselect();
				res = RES_OK;
			}
			break;

		case GET_SECTOR_COUNT :	/* Get number of sectors on the disk (DWORD) */
			if ((send_cmd(CMD9, 0L) == 0) && !rcvr_datablock(csd, 16)) {
				if ((csd[0] >> 6) == 1) {	/* SDC ver 2.00 */
					csize = csd[9] + ((WORD)csd[8] << 8) + 1;
					*(DWORD*)buff = (DWORD)csize << 10;
				} else {					/* SDC ver 1.XX or MMC */
					n = (csd[5] & 15) + ((csd[10] & 128) >> 7) + ((csd[9] & 3) << 1) + 2;
					csize = (csd[8] >> 6) + ((WORD)csd[7] << 2) + ((WORD)(csd[6] & 3) << 10) + 1;
					*(DWORD*)buff = (DWORD)csize << (n - 9);
				}
				res = RES_OK;
			}
			break;

		case GET_SECTOR_SIZE :	/* Get R/W sector size (WORD) */
			*(WORD*)buff = 512;
			res = RES_OK;
			break;

		case GET_BLOCK_SIZE :	/* Get erase block size in unit of sector (DWORD) */
			if (CardType & CT_SD2) {			/* SDv2 */
				if (send_cmd(ACMD13, 0L) == 0) {		/* Read SD status */
					SPI_getData(&dummy,1);
					if (!rcvr_datablock(csd, 16)) {				/* Read partial block */
						for (n = 64 - 16; n; n--) SPI_getData(&dummy,1);	/* Purge trailing data */
						*(DWORD*)buff = 16UL << (csd[10] >> 4);
						res = RES_OK;
					}
				}
			} else {					/* SDv1 or MMCv3 */
				if ((send_cmd(CMD9, 0L) == 0) && !rcvr_datablock(csd, 16)) {	/* Read CSD */
					if (CardType & CT_SD1) {	/* SDv1 */
						*(DWORD*)buff = (((csd[10] & 63) << 1) + ((WORD)(csd[11] & 128) >> 7) + 1) << ((csd[13] >> 6) - 1);
					} else {					/* MMC */
						*(DWORD*)buff = ((WORD)((csd[10] & 124) >> 2) + 1) * (((csd[11] & 3) << 3) + ((csd[11] & 224) >> 5) + 1);
					}
					res = RES_OK;
				}
			}
			break;

		case MMC_GET_TYPE :		/* Get card type flags (1 byte) */
			*ptr = CardType;
			res = RES_OK;
			break;

		case MMC_GET_CSD :		/* Receive CSD as a data block (16 bytes) */
			if (send_cmd(CMD9, 0L) == 0		/* READ_CSD */
				&& !rcvr_datablock(ptr, 16))
				res = RES_OK;
			break;

		case MMC_GET_CID :		/* Receive CID as a data block (16 bytes) */
			if (send_cmd(CMD10, 0L) == 0		/* READ_CID */
				&& !rcvr_datablock(ptr, 16))
				res = RES_OK;
			break;

		case MMC_GET_OCR :		/* Receive OCR as an R3 resp (4 bytes) */
			if (send_cmd(CMD58, 0L) == 0) {	/* READ_OCR */
				SPI_getData(ptr,4);
				res = RES_OK;
			}
			break;

		case MMC_GET_SDSTAT :	/* Receive SD statsu as a data block (64 bytes) */
			if (send_cmd(ACMD13, 0L) == 0) {	/* SD_STATUS */
				SPI_getData(&dummy,1);
				if (!rcvr_datablock(ptr, 64))
					res = RES_OK;
			}
			break;

		default:
			res = RES_PARERR;
	}

	deselect();

	return res;
}

